package com.upyuns.platform.rs.website.biz;

import com.github.wxiaoqi.security.common.msg.ObjectRestResponse;
import com.github.wxiaoqi.security.common.util.Query;
import com.github.wxiaoqi.security.common.vo.PageDataVO;
import com.upyuns.platform.rs.website.dto.NoticeInfoDto;
import org.springframework.stereotype.Service;

import com.upyuns.platform.rs.website.entity.NoticeInfo;
import com.upyuns.platform.rs.website.mapper.NoticeInfoMapper;
import com.github.wxiaoqi.security.common.biz.BaseBiz;
import tk.mybatis.mapper.entity.Example;

import java.util.Date;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * 通知信息
 *
 * @author zjw
 * @email jiaoruizhen@126.com
 * @date 2020-12-28 14:12:25
 */
@Service
public class NoticeInfoBiz extends BaseBiz<NoticeInfoMapper,NoticeInfo> {

	public void addObj(String message, Integer type, Integer userId, String relationId) {
			insertSelectiveRe(new NoticeInfo(){{setMessage(message); setType(type); setUserId(userId); setRelationId(relationId); setCrtTime(new Date());setUpdTime(new Date());}});
	}

	/**
	 * 查询用户所有通知信息
	 * @param noticeInfoDto
	 * @return
	 */
	public ObjectRestResponse getByUserId(NoticeInfoDto noticeInfoDto) {
		Example example = new Example(NoticeInfo.class);
		Example.Criteria criteria = example.createCriteria();
		if (noticeInfoDto.getRead() != null) {
			criteria.andEqualTo("read", noticeInfoDto.getRead());
		}
		criteria.andEqualTo("userId", noticeInfoDto.getUserId());
		example.orderBy("read");
		Query query = new Query(noticeInfoDto);
		PageDataVO<NoticeInfo> pageDataVO = PageDataVO.pageInfo(query, () -> mapper.selectByExample(example));
		return ObjectRestResponse.succ(pageDataVO);
	}

}