package com.upyuns.platform.rs.website.controller.web;

import com.github.wxiaoqi.security.admin.feign.UserFeign;
import com.github.wxiaoqi.security.admin.feign.rest.UserRestInterface;
import com.github.wxiaoqi.security.common.msg.ObjectRestResponse;
import com.github.wxiaoqi.security.common.rest.BaseController;
import com.upyuns.platform.rs.website.biz.NoticeInfoBiz;
import com.upyuns.platform.rs.website.dto.NoticeInfoDto;
import com.upyuns.platform.rs.website.entity.NoticeInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("noticeInfo/web")
public class NoticeInfoWebController extends BaseController<NoticeInfoBiz,NoticeInfo> implements UserRestInterface {

	@Autowired
	UserFeign userFeign;

	@Override
	public UserFeign getUserFeign() {
		return userFeign;
	}

	@GetMapping(value = "getAllByUser")
	public ObjectRestResponse getUserList(NoticeInfoDto noticeInfoDto) {
		noticeInfoDto.setUserId(getAppUser().getUserid());
		return baseBiz.getByUserId(noticeInfoDto);
	}
}